#
# Pretty print out of a Glim model's results
#
# SCCS  @(#)glim.print.s	4.1   11/19/90
#

glim.print <- function(glim.list, digits=4, scale=F) {

    coef <- glim.list$coef
    se  <-  sqrt(diag(glim.list$var))
    if (scale) dev <- glim.list$deviance / glim.list$scale
    else       dev <- glim.list$deviance
    df  <- glim.list$df
    if (is.null(coef) | is.null(se) | is.null(dev) | is.null(df))
	    stop("Input is not valid")

    olddigit <- options("digits")
    options(digits=digits)
    on.exit(options(olddigit))

    pval <- format(round(1-pchisq((coef/se)^2,1),4))
    tmp <-  cbind(format(coef),  format(se), format(round(coef/se,2)),  pval)

    model <- length(coef) + min(df) - df
    if(model[1] == 0) {
# first model has no intercept
	model <- model + 1
	tmp <- rbind(rep("   ", 4), tmp)
	row.names <- c("NULL", names(coef))
    }
    else row.names <- names(coef)
    xdev <- xdf <- xchange <- xp <- rep("", length(coef))
    xdev[model] <- paste("   ",format(dev))
    xdf[model]  <- format(df)
    model <- model[-1]
    xchange[model] <- format(round( - diff(dev), 1))
    if(scale)
	xpp <- pf( - diff(dev),  - diff(df), (rev(df))[1])
    else xpp <- pchisq( - diff(dev),  - diff(df))
    xp[model] <- format(round(1 - xpp, 4))
    temp <- cbind(tmp, xdev, xdf, xchange, xp)
    dimnames(temp) <- NULL  #work around a bug in prmatrix
    prmatrix(temp, quote = F, rowlab = row.names, collab = c("coef",
	"se(coef)", "z", "p", "Deviance", "df", "change", "p"))

    cat("\n")
    invisible()
    }

