/* ************************************************************************ */
/* Header file for the `xvertext' routines.                                 */
/* Copyright (c) 1992 Alan Richardson (mppa3@uk.ac.sussex.syma)             */
/* ************************************************************************ */

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#define TLEFT   1
#define TCENTRE 2
#define TRIGHT  3
#define MLEFT   4
#define MCENTRE 5
#define MRIGHT  6
#define BLEFT   7
#define BCENTRE 8
#define BRIGHT  9

/* *** The font structures *** */

typedef struct {
	int bit_w;
	int bit_h;

	Pixmap bm;
} BitmapStruct;

typedef struct {
	int ascent;
	int descent;
	int lbearing;
	int rbearing;
	int width;

	BitmapStruct glyph;
} XRotCharStruct;

typedef struct {
	int dir;
	int height;
	int max_ascent, max_descent;
	int max_char, min_char;
	char *name[200];

	XFontStruct *xfontstruct;

	XRotCharStruct per_char[95];
} XRotFontStruct;


extern XRotFontStruct *XRotLoadFont();
extern void XRotUnloadFont();
extern int XRotTextWidth();
extern void XRotDrawString();
extern void XRotDrawImageString();
extern void XRotDrawAlignedString();
extern void XRotDrawAlignedImageString();
extern void XVertEnd();
